<?php

/**
 * ActionsSecureMyDolibarr class
 */

class ActionsSecureMyDolibarr
{
	/**
	 * Control user(s) access
	 *
	 */
	protected function controlAccess()
	{
		global $conf, $user;

		if (! empty($conf->global->SECURE_MY_DOLIBARR_DISALLOWED_USERS))
		{
			$disallowed_users = explode(',', $conf->global->SECURE_MY_DOLIBARR_DISALLOWED_USERS);

			if (in_array($user->id, $disallowed_users)) {
				dol_include_once('securemydolibarr/tpl/access_forbidden.php');
				exit;
			}
		}
	}

	/**
	 * Overloading the afterLogin function
	 *
	 * @param   array()         $parameters     Hook metadatas (context, etc...)
	 * @param   CommonObject    &$object        The object to process (an invoice if you are in invoice module, a propale in propale's module, etc...)
	 * @param   string          &$action        Current action (if set). Generally create or edit or null
	 * @param   HookManager     $hookmanager    Hook manager propagated to allow calling another hook
	 * @return  int                             < 0 on error, 0 on success, 1 to replace standard code
	 */
	public function afterLogin($parameters, &$object, &$action, $hookmanager)
	{
		$error = 0; // Error counter

		if (in_array('login', explode(':', $parameters['context'])))
		{
			$this->controlAccess();
		}

		if (! $error)
		{
			return 0; // or return 1 to replace standard code
		}
		else
		{
			return -1;
		}
	}

	/**
	 * Overloading the updateSession function
	 *
	 * @param   array()         $parameters     Hook metadatas (context, etc...)
	 * @param   CommonObject    &$object        The object to process (an invoice if you are in invoice module, a propale in propale's module, etc...)
	 * @param   string          &$action        Current action (if set). Generally create or edit or null
	 * @param   HookManager     $hookmanager    Hook manager propagated to allow calling another hook
	 * @return  int                             < 0 on error, 0 on success, 1 to replace standard code
	 */
	public function updateSession($parameters, &$object, &$action, $hookmanager)
	{
		$error = 0; // Error counter

		if (in_array('main', explode(':', $parameters['context'])))
		{
			$this->controlAccess();
		}

		if (! $error)
		{
			return 0; // or return 1 to replace standard code
		}
		else
		{
			return -1;
		}
	}
}
